#include <iostream>
#include <cmath>
#include <simplecpp>

using namespace std;

int main()

{
    int a, b, ngapsrx;
    double ngapsry;
    double k;
    double i;

    a = 1;
    b = 3;


    int nirx; //nirx/y is number of integers in the given range of x/y



    nirx = b + 1 - a  ;



    ngapsrx = nirx - 1;

    initCanvas("Graph Plotter", 700, 700);

    double ymax, ymin, mymin, mymax;// ymax & ymin is maxima & minima of y = f(x). mymax/mymin is absolute value of ymax & ymin
    double y[100*ngapsrx +1], x[100*ngapsrx +1];

    for (int i = 0; i < 100*ngapsrx +1; i++)       //Calculating the value of function
    {
        x[i] =  a + i*0.01;
        y[i] = exp(x[i]) -2 ;
        ymax = y[0];
        ymin = y[0];
    }

    y[100*ngapsrx +1] = y[100*ngapsrx];
    x[100*ngapsrx +1] = x[100*ngapsrx];

    for (int i = 0; i < 100*ngapsrx +1; i++)
    {
        if(y[i] >= ymax)
        {
            ymax = y[i];
            mymax = ymax;
        }
        if(y[i] <= ymin)
        {
            ymin = y[i];
            mymin = ymin;
        }
    }

    if(ymax < 0)
    {
        mymax = -1 * ymax;
    }
    if(ymin < 0)
    {
        mymin = -1 * ymin;
    }

    //Now function will go to proper plotting



    //function type 1: BEGINS

    if( a >= 0 && b >= 0 && ymax >= 0 && ymin <= 0)
    {
        Line yaxs(50,0,50,700); // Y axis

        ngapsry = ymax - ymin;
        Line xaxis(0,50 + mymax * 600/ngapsry,700,50 + mymax * 600/ngapsry); //X axis
        xaxis.imprint();
        for (i =0, k= a; i < nirx, k < b + 1 ; i++, k++)
        {
            Text x1(50 + i * 600/ngapsrx,65 + mymax * 600/ngapsry, k );
            x1.imprint();
            Line l2 (50 + i * 600/ngapsrx,45 + mymax * 600/ngapsry,50 + i * 600/ngapsrx,55 + mymax * 600/ngapsry);
            l2.imprint();
        }
        for ( i = ymax , k = 0; i > -1, k < ymax + 1; i--, k++)
        {
            Text y1(40, 50 + i * 600/ngapsry, k);
            y1.imprint();
            Line l2(45 , 50 + i * 600/ngapsry,55, 50 + i * 600/ngapsry);
            l2.imprint();
        }
        for (i = 0, k = 0; i < mymin +1, k > ymin - 1; i++, k--)
        {
            Text y1(35, 50 + (ymax + i) * 600/ngapsry, k);
            y1.imprint();
            Line l2 (45 ,50 + (ymax + i) * 600/ngapsry,55 ,50 + (ymax + i) * 600/ngapsry);
            l2.imprint();
        }
        for (int i = 0; i < 100*ngapsrx +1; i++)
        {
            Line l1(50 + i* 0.01 *600/ngapsrx,650-(mymin + y[i])*600/ngapsry,50 + (i+1) * 0.01 *600/ngapsrx,650-(mymin + y[i+1])*600/ngapsry);
            l1.setColor(COLOR("red"));
            l1.imprint();
            l1.setColor(COLOR("blue"));
        }
        wait(60);
    }

    //function type 1: ENDS



    //function type 2: BEGINS

    if( a >= 0 && b >= 0 && ymax >= 0 && ymin >= 0)
    {
        Line yaxs(50,0,50,700); // Y axis

        ngapsry = ymax;
        Line xaxis(0,50 + mymax * 600/ngapsry,700,50 + mymax * 600/ngapsry); // x axis
        xaxis.imprint();
        for (i =0, k = a; i < nirx, k < b +1 ; i++, k++)
        {
            Text x1(50 + i * 600/ngapsrx,65 + mymax * 600/ngapsry, k);
            x1.imprint();
            Line l2 (50 + i * 600/ngapsrx,45 + mymax * 600/ngapsry,50 + i * 600/ngapsrx,55 + mymax * 600/ngapsry);
            l2.imprint();
        }
        for ( i = ymax , k = 0; i > -1, k < ymax + 1; i--, k++)
        {
            Text y1(40, 50 + i * 600/ngapsry, k);
            y1.imprint();
            Line l2(45 , 50 + i * 600/ngapsry,55, 50 + i * 600/ngapsry);
            l2.imprint();
        }
        for (int i = 0; i < 100*ngapsrx +1; i++)
        {
            Line l1(50 + i * 0.01 *600/ngapsrx,650-(y[i])*600/ngapsry,50 + (i+1)*0.01 *600/ngapsrx,650-(y[i+1])*600/ngapsry);
            l1.setColor(COLOR("red"));
            l1.imprint();
            l1.setColor(COLOR("blue"));
        }
        wait(60);
        if ( a >=0 && b >= 0)
        {
            nirx = b + 1 - a  ;
        }
    }

    //function type 2: ENDS



    //function type 3: BEGINS

    if( a >= 0 && b >= 0 && ymax <= 0 && ymin <= 0)
    {
        Line yaxs(50,0,50,700);
        ngapsry = mymin;
        Line xaxis(0,50,700,50 );
        xaxis.imprint();
        for (i =0, k = a; i < nirx, k< b+1 ; i++, k++)
        {
            Text x1(50 + i * 600/ngapsrx,35, k );
            x1.imprint();
            Line l2 (50 + i * 600/ngapsrx,45,50 + i * 600/ngapsrx,55);
            l2.imprint();
        }
        for (i = 0, k = 0; i < mymin +1, k > ymin - 1; i++, k--)
        {
            Text y1(35, 50 + i * 600/ngapsry, k);
            y1.imprint();
            Line l2 (45 ,50 + i * 600/ngapsry,55 ,50 + i * 600/ngapsry);
            l2.imprint();
        }

        for (int i = 0; i < 100*ngapsrx +1; i++)
        {
            Line l1(50 + i * 0.01 *600/ngapsrx,50 + (-1 * y[i])*600/ngapsry,50 + (i+1)*0.01 *600/ngapsrx,50 + (-1 * y[i+1])*600/ngapsry);
            l1.setColor(COLOR("red"));
            l1.imprint();
            l1.setColor(COLOR("blue"));
        }
        wait(60);
    }

    //function type 3: ENDS




    //function type 4: BEGINS

    if( a <= 0 && b >= 0 && ymax >= 0 && ymin <= 0)
    {
        ngapsry = ymax - ymin;
        Line xaxis(0,50 + mymax * 600/ngapsry,700,50 + mymax * 600/ngapsry);
        xaxis.imprint();

        Line yaxs(50 + (-1 * a * 600/ngapsrx),0,50 + (-1 * a * 600/ngapsrx),700);

        for (i =0, k= a; i < nirx, k < b + 1 ; i++, k++)
        {
            Text x1(50 + i * 600/ngapsrx,65 + mymax * 600/ngapsry, k );
            x1.imprint();
            Line l2 (50 + i * 600/ngapsrx,45 + mymax * 600/ngapsry,50 + i * 600/ngapsrx,55 + mymax * 600/ngapsry);
            l2.imprint();
        }
        for ( i = ymax , k = 0; i > -1, k < ymax + 1; i--, k++)
        {
            Text y1(35 + (-1 * a * 600/ngapsrx), 50 + i * 600/ngapsry, k);
            y1.imprint();
            Line l2(45 + (-1 * a * 600/ngapsrx), 50 + i * 600/ngapsry,55 + (-1 * a * 600/ngapsrx), 50 + i * 600/ngapsry);
            l2.imprint();
        }
        for (i = 0, k = 0; i < mymin +1, k > ymin - 1; i++, k--)
        {
            Text y1(35  + (-1 * a * 600/ngapsrx), 50 + (i + ymax) * 600/ngapsry, k);
            y1.imprint();
            Line l2(45 + (-1 * a * 600/ngapsrx), 50 + (i + ymax) * 600/ngapsry,55 + (-1 * a * 600/ngapsrx), 50 + (i + ymax) * 600/ngapsry);
            l2.imprint();
        }

        for (int i = 0; i < 100*ngapsrx +1; i++)
        {
            Line l1(50 + i* 0.01 *600/ngapsrx,650-(mymin + y[i])*600/ngapsry,50 + (i+1)* 0.01 *600/ngapsrx,650-(mymin + y[i+1])*600/ngapsry);
            l1.setColor(COLOR("red"));
            l1.imprint();
            l1.setColor(COLOR("blue"));
        }
        wait(60);
    }

    //function type 4: ENDS



    //function type 5: BEGINS

    if( a <= 0 && b >= 0 && ymax >= 0 && ymin >= 0)
    {
        ngapsry = ymax;
        Line xaxis(0,50 + mymax * 600/ngapsry,700,50 + mymax * 600/ngapsry);
        xaxis.imprint();

        Line yaxs(50 + (-1 * a * 600/ngapsrx),0,50 + (-1 * a * 600/ngapsrx),700);

        for (i =0, k = a; i < nirx, k < b +1 ; i++, k++)
        {
            Text x1(50 + i * 600/ngapsrx,65 + mymax * 600/ngapsry, k);
            x1.imprint();
            Line l2 (50 + i * 600/ngapsrx,45 + mymax * 600/ngapsry,50 + i * 600/ngapsrx,55 + mymax * 600/ngapsry);
            l2.imprint();
        }
        for ( i = ymax , k = 0; i > -1, k < ymax + 1; i--, k++)
        {
            Text y1(35 + (-1 * a * 600/ngapsrx), 50 + i * 600/ngapsry, k);
            y1.imprint();
            Line l2(45 + (-1 * a * 600/ngapsrx), 50 + i * 600/ngapsry,55 + (-1 * a * 600/ngapsrx), 50 + i * 600/ngapsry);
            l2.imprint();
        }
        for (int i = 0; i < 100*ngapsrx +1; i++)
        {
            Line l1(50 + i* 0.01 *600/ngapsrx,650-(y[i])*600/ngapsry,50 + (i+1)* 0.01 *600/ngapsrx,650-(y[i+1])*600/ngapsry);
            l1.setColor(COLOR("red"));
            l1.imprint();
            l1.setColor(COLOR("blue"));
        }
        wait(60);
    }

    //function type 5: ENDS




    //function type 6: BEGINS

    if( a <= 0 && b >= 0 && ymax <= 0 && ymin <= 0)
    {
        ngapsry = mymin;
        Line xaxis(0,50,700,50 );
        xaxis.imprint();

        Line yaxs(50 + (-1 * a * 600/ngapsrx),0,50 + (-1 * a * 600/ngapsrx),700);
        yaxs.imprint();

        for (int i =0, k = a; i < nirx, k< b+1 ; i++, k++)
        {
            Text x1(50 + i * 600/ngapsrx,35, k );
            x1.imprint();
            Line l2 (50 + i * 600/ngapsrx,45,50 + i * 600/ngapsrx,55);
            l2.imprint();
        }

        for (i = 0, k = 0; i < mymin +1, k > ymin - 1; i++, k--)
        {
            Text y1(35  + (-1 * a * 600/ngapsrx), 50 + i * 600/ngapsry, k);
            y1.imprint();
            Line l2(45 + (-1 * a * 600/ngapsrx), 50 + i * 600/ngapsry,55 + (-1 * a * 600/ngapsrx), 50 + i * 600/ngapsry);
            l2.imprint();
        }
        for (int i = 0; i < 100*ngapsrx +1; i++)
        {
            Line l1(50 + i * 0.01 *600/ngapsrx,50 + (-1 * y[i])*600/ngapsry,50 + (i+1)*0.01 *600/ngapsrx,50 + (-1 * y[i+1])*600/ngapsry);
            l1.setColor(COLOR("red"));
            l1.imprint();
            l1.setColor(COLOR("blue"));
        }
        wait(60);
    }

    //function type 6: ENDS






    //function type 7: BEGINS

    if( a < 0 && b < 0 && ymax >= 0 && ymin <= 0)
    {
        ngapsry = ymax - ymin;
        Line yaxs(650,0,650,700);
        Line xaxis(0,50 + mymax * 600/ngapsry,700,50 + mymax * 600/ngapsry);
        xaxis.imprint();
        for (i =0, k = a; i < nirx, k < b + 1 ; i++, k++)
        {
            Text x1(50 + i * 600/ngapsrx,65 + mymax * 600/ngapsry, k );
            x1.imprint();
            Line l2 (50 + i * 600/ngapsrx,45 + mymax * 600/ngapsry,50 + i * 600/ngapsrx,55 + mymax * 600/ngapsry);
            l2.imprint();
        }
        for ( i = ymax , k = 0; i > -1, k < ymax + 1; i--, k++)
        {
            Text y1(665, 50 + i * 600/ngapsry, k);
            y1.imprint();
            Line l2(645 , 50 + i * 600/ngapsry,655, 50 + i * 600/ngapsry);
            l2.imprint();
        }

        for (i = 0, k = 0; i < mymin +1, k > ymin - 1; i++, k--)
        {
            Text y1(665, 50 + (i+ ymax) * 600/ngapsry, k);
            y1.imprint();
            Line l2 (645 ,50 + (i+ ymax) * 600/ngapsry,655 ,50 + (i+ ymax) * 600/ngapsry);
            l2.imprint();
        }
        for (int i = 0; i < 100*ngapsrx +1; i++)
        {
            Line l1(50 + i * 0.01 *600/ngapsrx,50+ (ymax - y[i]) *600/ngapsry,50 + (i+1)* 0.01 *600/ngapsrx,50+ (ymax -y[i+1]) *600/ngapsry);
            l1.setColor(COLOR("red"));
            l1.imprint();
            l1.setColor(COLOR("blue"));
        }
        wait(60);
    }

    //function type 7: ENDS





    //function type 8: BEGINS

    if( a < 0 && b < 0 && ymax >= 0 && ymin >= 0)
    {
        ngapsry = ymax;
        Line yaxs(650,0,650,700);

        Line xaxis(0,50 + mymax * 600/ngapsry,700,50 + mymax * 600/ngapsry);
        xaxis.imprint();
        for (i =0, k = a ; i < nirx, k < b + 1 ; i++, k++)
        {
            Text x1(50 + i * 600/ngapsrx,65 + mymax * 600/ngapsry, k);
            x1.imprint();
            Line l2 (50 + i * 600/ngapsrx,45 + mymax * 600/ngapsry,50 + i * 600/ngapsrx,55 + mymax * 600/ngapsry);
            l2.imprint();
        }

        for ( i = ymax , k = 0; i > -1, k < ymax + 1; i--, k++)
        {
            Text y1(665, 50 + i * 600/ngapsry, k);
            y1.imprint();
            Line l2(645 , 50 + i * 600/ngapsry,655, 50 + i * 600/ngapsry);
            l2.imprint();
        }
        for (int i = 0; i < 100*ngapsrx +1; i++)
        {
            Line l1(50 + i * 0.01 *600/ngapsrx,50+ (ymax - y[i]) *600/ngapsry,50 + (i+1)* 0.01 *600/ngapsrx,50+ (ymax -y[i+1]) *600/ngapsry);
            l1.setColor(COLOR("red"));
            l1.imprint();
            l1.setColor(COLOR("blue"));
        }
        wait(60);
    }

    //function type 8: ENDS





    //function type 9: BEGINS

    if( a < 0 && b < 0 && ymax <= 0 && ymin <= 0)
    {
        ngapsry = mymin;
        Line yaxs(650,0,650,700);

        Line xaxis(0,50,700,50);
        xaxis.imprint();
        for (i =0, k = a ; i < nirx, k < b + 1 ; i++, k++)
        {
            Text x1(50 + i * 600/ngapsrx,35 , k);
            x1.imprint();
            Line l2 (50 + i * 600/ngapsrx,45 ,50 + i * 600/ngapsrx,55);
            l2.imprint();
        }

        for (i = 0, k = 0; i < mymin +1, k > ymin - 1; i++, k--)
        {
            Text y1(665, 50 + i * 600/ngapsry, k);
            y1.imprint();
            Line l2 (645 ,50 + i * 600/ngapsry,655 ,50 + i * 600/ngapsry);
            l2.imprint();
        }
        for (int i = 0; i < 100*ngapsrx +1; i++)
        {
            Line l1(50 + i * 0.01 *600/ngapsrx,50+ ((-1 * y[i])) *600/ngapsry,50 + (i+1)* 0.01 *600/ngapsrx,50+ (-1 * y[i+1]) *600/ngapsry);
            l1.setColor(COLOR("red"));
            l1.imprint();
            l1.setColor(COLOR("blue"));
        }
        wait(60);
    }

    //function type 9: ENDS




    //All type function going ends

}
